> ## Documentation Index
> Fetch the complete documentation index at: https://docs.methodfi.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a Secret

export const ParamList = ({items = [], is_child = false}) => {
  return items.map(item => {
    const field_props = {
      id: Math.random().toString(),
      body: item.name,
      name: item.name,
      type: item.type,
      required: item.required
    };
    const enums = item.enums || [];
    const items = item.items || [];
    const has_items = items?.length > 0;
    const has_enums = enums?.length > 0;
    const should_default_open = item.defaultOpen || false;
    const render_child_item = () => {
      const child_props = {
        title: has_enums ? "Possible enum values" : "properties"
      };
      if (should_default_open) child_props.defaultOpen = true;
      const has_inline_enums = has_enums && enums.every(enum_item => typeof enum_item === 'string') && enums.map((enum_item, idx) => {
        const is_last = idx === enums.length - 1;
        const is_2nd_to_last = idx === enums.length - 2;
        return <>
            <code>{enum_item}</code>
            {is_last && ''}
            {is_2nd_to_last && ' or '}
            {!is_last && !is_2nd_to_last && ', '}
          </>;
      });
      const enum_list = has_enums && !has_inline_enums && <Accordion {...child_props}>
          {enums.map((enum_item, index) => <div key={`enum-${index}`}>
              <code>{enum_item.name}</code>
              <br />
              <p>{enum_item.description}</p>
            </div>)}
        </Accordion>;
      const item_list = has_items && <Expandable {...child_props}>
          <ParamList items={items || []} is_child />
        </Expandable>;
      return <>
          <p>
            {item.description}
            {has_inline_enums && [has_inline_enums.length > 1 ? ' One of ' : ' Must be ', ...has_inline_enums]}
          </p>

          {enum_list}
          {item_list}
        </>;
    };
    return is_child ? <ResponseField {...field_props}>{render_child_item()}</ResponseField> : <ParamField {...field_props}>{render_child_item()}</ParamField>;
  });
};

Creates a new Secret to securely store a sensitive value.

## Body

<ParamList
  items={[
{
name: 'value',
type: 'string',
required: true,
description: 'The secret value to store (e.g., an API key or token). This value will be encrypted and cannot be retrieved after creation.',
},
{
name: 'metadata',
type: 'object',
required: false,
description: 'Additional data to store with the Secret.',
},
]}
/>

## Returns

Returns the newly created Secret object. Note that the `value` field is not returned in the response.

<RequestExample>
  ```bash cURL theme={null}
  curl https://production.methodfi.com/secrets \
    -X POST \
    -H "Method-Version: 2026-03-30" \
    -H "Authorization: Bearer sk_WyZEWVfTcH7GqmPzUPk65Vjc" \
    -H "Content-Type: application/json" \
    -d '{
      "value": "pk_1234567890",
      "metadata": {
        "environment": "production"
      }
    }'
  ```

  ```javascript Node.js theme={null}
  const secret = await method.secrets.create({
    value: 'pk_1234567890',
    metadata: {
      environment: 'production'
    }
  });
  ```

  ```python Python theme={null}
  secret = method.secrets.create({
    'value': 'pk_1234567890',
    'metadata': {
      'environment': 'production'
    }
  })
  ```
</RequestExample>

<ResponseExample>
  ```json theme={null}
  {
    "id": "sec_au22b1fbFrmfp",
    "metadata": {
      "environment": "production"
    },
    "created_at": "2025-12-04T18:50:54.024Z",
    "updated_at": "2025-12-04T18:50:54.024Z",
    "status": "active"
  }
  ```
</ResponseExample>
